<?php
namespace Teknisa\CRM\Controller;

use Zeedhi\Framework\DTO;

class InterlocutoresPendentesController{
    protected $interlocService;
    
    public function __construct ($environment, $interlocService, $enviarMensagemController){
        $this->interlocService   = $interlocService;
        $this->environment   = $environment;
        $this->enviarMensagemController   = $enviarMensagemController;
    }
    
    public function setClientInPendInt(DTO\Request $request, DTO\Response $response){
        try{
            
            $rows = $request->getDataset()->getRows();
            $interlocs = array();
            
            foreach ($rows as &$row) {
                $interlocs[$row['NMINTERLOCUTOR']] = $this->interlocService->setClientInPendInt($row);
            }
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('INTERLOCUTOR', $interlocs));
            
        }catch(\Exception $e){
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
    public function sentMail(DTO\Request $request, DTO\Response $response){
        try{
            
            $rows = $request->getDataset()->getRows();
            $interlocs = array();
            
            foreach ($rows as &$row) {
                $mensagem = array();
                
                $mensagem['LINK'] = "https://crm.teknisa.com/#/product#/crm_profile?nrparcnegocio=".$row['NRPARCNEGOCIO'];
                $mensagem['LABELLINK'] = "para completar seu cadastro e acompanhar seu ticket";
                
                $mensagem['DSTITULOMENSAGEM'] = 'CRM - Ativação de Operador';
                $mensagem['DSMENSAGEM']    = '<table border="0" width="100%" cellpadding="0" cellspacing="0" bgcolor="eeeeee" style="background-color: #eeeeee;"> <tbody> <tr> <td> <table border="0" align="center" width="590" cellpadding="0" cellspacing="0" bgcolor="0274BA" class="container590" style="background-color: #0274ba; text-align: center;"> <tbody> <tr> <td> <table border="0" align="center" width="540" cellpadding="0" cellspacing="0" class="container580"> <tbody> <tr> <td align="center" valign="middle"> <table border="0" align="middle" cellpadding="0" cellspacing="0" style="border-collapse:collapse; mso-table-lspace:0pt; mso-table-rspace:0pt;" class=""> <tbody> <tr> <td align="center" valign="middle"> <p style="color: #ffffff; font-size: 25px; padding:35px !important; font-family: Helvetica, sans-serif; line-height: 24px; ">NOTIFICAÇÃO DE TICKET</p> <p style="color: #ffffff; font-size: 16px; font-family: " Questrial ", Helvetica, sans-serif; line-height: 15px; padding-top:15px;"></p> <p style="color: #ffffff; font-size: 16px; font-family: " Questrial ", Helvetica, sans-serif; line-height: 15px; padding-top:15px;"></p> <p style="color: #ffffff; font-size: 16px; font-family: " Questrial ", Helvetica, sans-serif; line-height: 15px; padding-top:15px;"></p> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> <table border="0" width="100%" cellpadding="0" cellspacing="0" bgcolor="eeeeee"> <tbody> <tr> <td align="center"> <table border="0" align="center" width="590" cellpadding="0" cellspacing="0" bgcolor="ffffff" class="container590 bg_color"> <tbody> <tr> <td> <table border="0" align="center" width="540" cellpadding="0" cellspacing="0" class="container580"> <tbody> <tr> <td align="left" style="color: #39434b; font-size: 20px; font-family: " Montserrat ", Helvetica, sans-serif; font-weight: 400; padding-bottom:15px; padding-top:20px; line-height: 35px;" class="title_color"> <div style="line-height:22px;padding:20px;"> Prezado(a) [INTERLOCUTOR]</div> </td> </tr> <tr> <td align="left" class="title_color" style="color: #848999; font-size: 14px; font-family: " Questrial ", sans-serif; mso-line-height-rule: exactly; line-height: 24px; padding-bottom:15px;"> <div style="line-height: 24px; margin-top:-5px; margin-bottom:15px;"> <p>Verificamos que você abriu um Ticket mas ainda não completou o seu cadastro. </p> <a href="[LINK]">Clique aqui</a> <p style="display:inline">[LABELLINK] </p> <p>Atenciosamente,</p> <p>Equipe CRM</p> </div> </td> </tr> <tr> <td height="10" style="font-size: 10px; line-height: 10px;">&nbsp;</td> </tr> </tbody> </table> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table>';
                $mensagem['INTERLOCUTOR']  = $row['NMINTERLOCUTOR'];
                
                $this->enviarMensagemController->enviarEmail($mensagem, $this->environment->getNrOrgTrab(), null, null, $row['EMAIL'], $row['NMINTERLOCUTOR']);
                
                $interlocs[] = $this->interlocService->setDtultatuInterloc($row['NRSEQINTERLOCUTOR']);
                
            }
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('INTERLOCUTOR', $interlocs));
            
        }catch(\Exception $e){
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }    
    }
    
    public function cancelInterloc(DTO\Request\Row $row, DTO\Response $response){
        try{
            
            $row = $row->getRow();
            $return = $this->interlocService->cancelInterloc($row);
            
            if($return)
                $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('INTERLOCUTOR', array($return)));
            
        }catch(\Exception $e){
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }      
        
    }
    
}