<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Teknisa\Model\Util\NovoCodigo;
use Teknisa\Libs\Util\DateUtil;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\Util\Functions;

class MunicipioController extends TeknisaCrud {
    protected $dataSourceName = 'municipio';
    protected $environment;
    
    public function __construct ($crudService, $parameterBag, $municipioService, $environment){
        $this->parameterBag  = $parameterBag;
        $this->crudService   = $crudService;
        $this->environment   = $environment;
        $this->municipioService   = $municipioService;
        
        parent::__construct($crudService, $parameterBag);
    }
    
    public function save(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            if (\Zeedhi\Framework\Util\Functions::arrayKeyExists('CDMUNICIPIO', $row)) {
                if ($row['__is_new']) {
                    $row['CDMUNICIPIO'] = $this->geraCodigoMunicipio($row['CDPAIS'], $row['SGESTADO'], $this->environment->getNrOrgTrab());
                }
            } else {
                $row['CDMUNICIPIO'] = $this->geraCodigoMunicipio($row['CDPAIS'], $row['SGESTADO'], $this->environment->getNrOrgTrab());
            }
            $row['IDMUNIUTCONVNFE'] = "N";
            
            parent::save($request, $response);
            
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
    public function geraCodigoMunicipio($cdpais, $sgestado, $nrorg){
        return $this->municipioService->geraCodigoMunicipio($cdpais, $sgestado, $nrorg);
    }
}
?>