<?php

namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request\Filter;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Request\Row;
use Teknisa\CRM\Service\AgrupamentoParceiroController;

class crm33000000AssistenteDeAgendamentoController extends TeknisaCrud
{

	protected $dataSourceName = 'crm_candidato_prospect_infosparc';
	protected $dataSourceNameToSave = 'filacontato';
	protected $parameterBagColumns = array("IDTPOPERADOR", "NRREVENDA", "DIASULTEVOL", "DIASULTATIVCONC", "P_DTINICIO", "P_DTFIM", "CRM_NRORGTRAB");

	protected $newCode;
	protected $GeraTarefaAniverAnoAtualProcedure;
	protected $GeraTarefasParcRelacOperProcedure;
	protected $agrupamentoParceiroService;

	public function __construct($crudService, $parameterBag, $newCode, $GeraTarefaAniverAnoAtualProcedure, $GeraTarefasParcRelacOperProcedure, $agrupamentoParceiroService)
	{

		$this->newCode = $newCode;
		$this->GeraTarefaAniverAnoAtualProcedure = $GeraTarefaAniverAnoAtualProcedure;
		$this->GeraTarefasParcRelacOperProcedure = $GeraTarefasParcRelacOperProcedure;
		$this->agrupamentoParceiroService = $agrupamentoParceiroService;

		parent::__construct($crudService, $parameterBag);
	}

	public function newFilter (Filter $request, Response $response){
		$filterData = $request->getFilterCriteria()->getConditions();
		$result = $this->agrupamentoParceiroService->newFilterService($filterData);
        try {
            $response->addDataSet(new DataSet('crm_candidato_prospect', $result));
        } catch (\Exception $e) {
            // $response->addMessage(new Message($e->getMessage()));
        }
    }

	public function generateTasks(Request $request, Response $response)
	{
		$rows = $request->getDataSet()->getRows();
		$bloqueio = array();
		$msg = array();

		foreach ($rows as $row) {
			$relation = $this->agrupamentoParceiroService->verifyGroupRel($row);

			if (empty($relation)) {

				$row['NRSEQFILACONTA'] = $this->newCode->getCodeByTableName("FILACONTATO", $row["NRORG"]);
				$service = $this->agrupamentoParceiroService->insertTaskRel($row);
			} else {
				$pai = $this->agrupamentoParceiroService->verifyParcGroupRel($row)[1];
				$relation['PAI'] = $pai;
				$bloqueio[] = $relation;
			}
		}

		if (!empty($bloqueio)) {
			foreach ($bloqueio as $bloq) {
				$msg[] = array("msg" => 'Operação bloqueada! O parceiro "' . $bloq['NRINSCRICAOPARC'] . ' - ' . $bloq['NMPRINCIPALPARC'] . '" está relacionado ao parceiro: "' . $bloq['PAI']['NRINSCRICAOPARC'] . ' - ' . $bloq['PAI']['NMPRINCIPALPARC'] . '"!');
			}

			$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('msg', $msg));
		}
	}

	public function generateTasksByBirthday(Request $request, Response $response)
	{

		$row = $request->getRow();
		$bloqueio = array();
		$msg = array();

		$relation = $this->agrupamentoParceiroService->verifyGroupRel($row);

		if (empty($relation)) {
			$this->GeraTarefaAniverAnoAtualProcedure->executeProcedure($row);
		} else {
			$pai = $this->agrupamentoParceiroService->verifyParcGroupRel($row)[1];
			$relation['PAI'] = $pai;
			$bloqueio[] = $relation;
		}

		if (!empty($bloqueio)) {
			foreach ($bloqueio as $bloq) {
				$msg[] = array("msg" => 'Operação bloqueada! O parceiro "' . $bloq['NRINSCRICAOPARC'] . ' - ' . $bloq['NMPRINCIPALPARC'] . '" está relacionado ao parceiro: "' . $bloq['PAI']['NRINSCRICAOPARC'] . ' - ' . $bloq['PAI']['NMPRINCIPALPARC'] . '"!');
			}

			$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('msg', $msg));
		}
	}

	public function generateTasksByInterval(Request $request, Response $response)
	{

		$row = $request->getRow();
		$bloqueio = array();
		$msg = array();

		$relation = $this->agrupamentoParceiroService->verifyGroupRel($row);

		if (empty($relation)) {
			$this->GeraTarefasParcRelacOperProcedure->executeProcedure($row);
		} else {
			$pai = $this->agrupamentoParceiroService->verifyParcGroupRel($row)[1];
			$relation['PAI'] = $pai;
			$bloqueio[] = $relation;
		}

		if (!empty($bloqueio)) {
			foreach ($bloqueio as $bloq) {
				$msg[] = array("msg" => 'Operação bloqueada! O parceiro "' . $bloq['NRINSCRICAOPARC'] . ' - ' . $bloq['NMPRINCIPALPARC'] . '" está relacionado ao parceiro: "' . $bloq['PAI']['NRINSCRICAOPARC'] . ' - ' . $bloq['PAI']['NMPRINCIPALPARC'] . '"!');
			}

			$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('msg', $msg));
		}
	}
}
