<?php

namespace Teknisa\CRM\Service;

use Teknisa\Libs\Util\Environment;
use Teknisa\CRM\Factory\IntegracaoMauticFactory;
use Mautic\Auth\ApiAuth;


class IntegracaoMauticService {
    protected $mauticFactory;
    protected $environment;
    
    public function __construct(IntegracaoMauticFactory $mauticFactory,
        Environment $environment) {
            
        $this->mauticFactory   = $mauticFactory;
        $this->environment = $environment;
    }
    
    public function saveParamMautic($row) {
        $nrorg = $this->environment->getNrOrgTrab();
        $cdoperador = $this->environment->getCdOperador();
        $nrorgOper = $this->environment->getNrOrg();
        
        $params = array(
            "DSPUBLICKEYMAUTIC" => $row['DSPUBLICKEYMAUTIC'],
            "DSSECRETKEYMAUTIC" => $row['DSSECRETKEYMAUTIC'],
            "DSBASEURLMAUTIC"   => $row['DSBASEURLMAUTIC'],
            "MAUTICAUTH"        => $row['MAUTICAUTH'],
            "NRORG"             => $nrorg,
            "CDOPERADOR"        => $cdoperador,
            "NRORGOPER"         => $nrorgOper
        );
        
        $this->mauticFactory->saveParamMautic($params);
    }
    
}