/*---------------------------------------------------------+
+ PROCEDURE  CRIA_DIME                                     +
+ FUNO: CRIAO DE DIMENSES DE DW NA BASE DE DADOS      +
+                                                          +
+ CRIAO: 27/09/2007                                      +
+ RAPHAEL ERNANI RODRIGUES                                 +
+                                                          +
+---------------------------------------------------------*/
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'CRIA_DIME' AND
	        TYPE = 'P' 	            AND
	        U.UID = O.UID               AND
	        U.NAME = USER)
	DROP PROCEDURE CRIA_DIME
GO

create 
PROCEDURE CRIA_DIME @P_CDTABELADW   VARCHAR(30),
                    @P_CDITEMDIME   VARCHAR(30),
                    @P_NMITEMDIME   VARCHAR(30),
                    @P_CDTABELADIME VARCHAR(30),
                    @P_DSPKDIME     VARCHAR(30),
                    @P_DSITEMDIME   VARCHAR(30),
                    @P_DSPKDIME2    VARCHAR(30)
AS
   DECLARE  @V_COUNT       INTEGER;
   DECLARE  @V_COUNT2      INTEGER;
   DECLARE  @V_ERRO        INTEGER;
   DECLARE  @V_TRY         INTEGER;
   DECLARE  @V_NRSEQUEDIME VARCHAR(05);
   DECLARE  @V_NMITEMDIME  VARCHAR(30);
BEGIN
   SET @V_ERRO = 0;
   SET @V_TRY  = 0;   

   /*   INSERE DIMENSES   */
   SELECT @V_COUNT = COUNT(*)
   FROM   DIMENSAODW
   WHERE  CDTABELADW = @P_CDTABELADW
     AND  CDITEMDIME = @P_CDITEMDIME;
   IF @V_COUNT=0
   BEGIN
      IF @P_CDTABELADIME IS NOT NULL
      BEGIN
         BEGIN
            IF @P_DSPKDIME2 IS NULL
            BEGIN
               SELECT @V_COUNT = COUNT(*)
               FROM   DIMENSAODIME
               WHERE  CDTABELADIME = @P_CDTABELADIME
                 AND  DSPKDIME     = @P_DSPKDIME
                 AND  DSITEMDIME   = @P_DSITEMDIME;
               IF @V_COUNT<>0
               BEGIN                               
                  SET ROWCOUNT 1;  -- O PRIMEIRO REGISTRO QUE SATISFIZER A CONDIO
                  SELECT @V_NRSEQUEDIME = NRSEQUEDIME
                  FROM   DIMENSAODIME
                  WHERE  CDTABELADIME = @P_CDTABELADIME
                    AND  DSPKDIME     = @P_DSPKDIME
                    AND  DSITEMDIME   = @P_DSITEMDIME;
                  SET ROWCOUNT 0;
               END;
            END
            ELSE
            BEGIN
               SELECT @V_COUNT = COUNT(*)
               FROM   DIMENSAODIME
               WHERE  CDTABELADIME = @P_CDTABELADIME
                 AND  DSPKDIME     = @P_DSPKDIME
                 AND  DSITEMDIME   = @P_DSITEMDIME
                 AND  DSPKDIME2    = @P_DSPKDIME2;
               IF @V_COUNT<>0
               BEGIN                               
                  SET ROWCOUNT 1;  -- O PRIMEIRO REGISTRO QUE SATISFIZER A CONDIO
                  SELECT @V_NRSEQUEDIME = NRSEQUEDIME
                  FROM   DIMENSAODIME
                  WHERE  CDTABELADIME = @P_CDTABELADIME
                    AND  DSPKDIME     = @P_DSPKDIME
                    AND  DSITEMDIME   = @P_DSITEMDIME 
                    AND  DSPKDIME2    = @P_DSPKDIME2;
                  SET ROWCOUNT 0;
               END;               
            END;
         END;
      END
      ELSE   
      BEGIN
         SELECT @V_COUNT = COUNT(*)
         FROM   DIMENSAODIME
         WHERE  NMITEMDIME = @P_NMITEMDIME
         IF @V_COUNT<>0
         BEGIN                               
            SET ROWCOUNT 1;  -- O PRIMEIRO REGISTRO QUE SATISFIZER A CONDIO
            SELECT @V_NRSEQUEDIME = NRSEQUEDIME
            FROM   DIMENSAODIME
            WHERE  NMITEMDIME = @P_NMITEMDIME
            SET ROWCOUNT 0;
         END;         
      END;
      IF @V_COUNT=0 -- SE A DIMENSO NO EXISTIR, CRI-LA
      BEGIN
         SELECT @V_NRSEQUEDIME = RIGHT(REPLICATE('0', 5) + CAST(ISNULL(MAX(NRSEQUEDIME)+1,0) AS VARCHAR), 5)    
         FROM DIMENSAODIME;
         
         SET @V_NMITEMDIME = @P_NMITEMDIME;
         SET @V_COUNT      =1; -- O SISTEMA DEVE ENTRAR NO LOOP PELO MENOS UMA VEZ;
      
         WHILE (@V_COUNT <> 0) AND (@V_ERRO <> 1) 
         BEGIN 
            SELECT @V_COUNT = COUNT(*)
            FROM   DIMENSAODIME
            WHERE  NMITEMDIME = @V_NMITEMDIME;
            IF @V_COUNT<>0
            BEGIN
               IF LEN(@V_NMITEMDIME+ CAST(@V_TRY AS VARCHAR))<=30
               BEGIN
                  SET @V_NMITEMDIME = @V_NMITEMDIME + CAST(@V_TRY AS VARCHAR);
               END
               ELSE
               BEGIN
                  SET @V_TRY        = @V_TRY + 1;
                  SET @V_NMITEMDIME = @P_NMITEMDIME;
                  IF LEN(@V_NMITEMDIME+ CAST(@V_TRY AS VARCHAR))>=30
                  BEGIN
                     SET @V_ERRO = 1;
                  END;
               END;
            END
            ELSE
            BEGIN
               INSERT INTO DIMENSAODIME
               (NRSEQUEDIME,  NMITEMDIME,  CDTABELADIME,  DSPKDIME,  DSITEMDIME,  DSPKDIME2,  IDDIMENSAODW)
               VALUES
               (@V_NRSEQUEDIME,@V_NMITEMDIME,@P_CDTABELADIME,@P_DSPKDIME,@P_DSITEMDIME,@P_DSPKDIME2,'S'); 
            END;   
         END;
      END;

      IF @V_ERRO=0
      BEGIN
         SELECT @V_COUNT = COUNT(*)
         FROM TABELADW
         WHERE CDTABELADW = @P_CDTABELADW;
         IF @V_COUNT=0
         BEGIN
            INSERT INTO TABELADW 
            (CDTABELADW, NMTABELADW) 
            VALUES
            (@P_CDTABELADW, @P_CDTABELADW);
         END;
         
         INSERT INTO DIMENSAODW
         (CDTABELADW,CDITEMDIME,NRSEQUEDIME)
         VALUES
         (@P_CDTABELADW,@P_CDITEMDIME,@V_NRSEQUEDIME);
      END;    
   END; 
END;
GO

--VERSAO--
EXEC ATUVEROBJ'CRIA_DIME','4.11.000';
GO

-- VERSAO --
EXEC ATUVEROBJ 'CRIA_DIME','5.01.004';
GO

